



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Javascript参数传递中值和引用的一种理解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Javascript参数传递中值和引用的一种理解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 23:55:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>值（value）和引用(reference)是各种编程语言老生常谈的话题，js也不例外。</p>
<p>我将剖析一个例子的实际运行过程，跟大家分享我对js参数传递中的值和引用的理解。</p>
<p>参考官网<a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures" rel="external nofollow noreferrer">数据类型</a>的两种分类，本文将这两种分类简称为基本类型（boolean, null, undefined, string, number, symbol）和object类型。</p>
<p>首先，用一个example 演示参数传递的应用：</p>
<div>
<pre class="prettyprint linenums">var obj = {};<br />
obj.inner = 10;

var num = 10;<br />
var str = 'Hello';<br />
var boo = true;<br />
var oth = null;<br />
var und = undefined;<br />
var sym = Symbol('foo');

function passingobject(myobj){<br />
    myobj.inner  = 1 + myobj.inner ;<br />
}

function passingvalue(myvalue){<br />
  switch(typeof myvalue){<br />
    case 'number':<br />
        myvalue = myvalue + 1;<br />
        break;<br />
      case 'string':<br />
        myvalue = 'I am a new string now!';<br />
        break;<br />
      case 'boolean':<br />
        myvalue= false;<br />
        break;<br />
      default:<br />
        myvalue = 'Null, Undefined, or Symbol';<br />
     }<br />
  }

  console.log("before num = " + num);  // before num = 10<br />
  passingvalue(num);<br />
  console.log("after num = " + num);  // after num = 10<br />
  console.log("before str = " + str); // before str = Hello<br />
  passingvalue(str);<br />
  console.log("after str = " + str);  // after str = Hello<br />
  console.log("before boo = " + boo); // before boo = true<br />
  passingvalue(boo);<br />
  console.log("after boo = " + boo);  // after boo = false<br />
  console.log("before oth = " + oth); // before oth = null<br />
  passingvalue(oth);<br />
  console.log("after oth = " + oth);  // after oth = null<br />
  console.log("before und = " + und); // before und = undefined<br />
  passingvalue(und);<br />
  console.log("after und = " + und);  // after und = undefined<br />
  console.log(sym); // Symbol(foo)<br />
  passingvalue(sym);<br />
  console.log(sym); // Symbol(foo)<br />
  console.log("before obj.inner = " + obj.inner); // before obj.inner = 10<br />
  passingobject(obj); // after obj.inner = 11<br />
  console.log("after obj.inner = " + obj.inner);</pre>
</div>
<p>从example 1 的结果似乎可以总结出以下两条结论：</p>
<p>1. 传递的数据类型为基本类型（number, string boolean, null, undefined, symbol），在参数传递过程中，函数内部对传递值的操作并不影响原始值。</p>
<p>2. 传递的数据类型为object， 在参数传递过程中，函数内部对传递值的操作会导致原始值的改变。</p>
<p>然而， 有没有其他特殊情况呢？</p>
<p>有一种在stackoverflow讨论很火热的用法，跟结论二背道而行。example 2。</p>
<p>例子引自：http://stackoverflow.com/questions/518000/is-javascript-a-pass-by-reference-or-pass-by-value-language</p>
<div>
<pre class="prettyprint linenums"> function changeStuff(a, b, c)<br />
 {<br />
   a = a * 10;<br />
   b.item = "changed";<br />
   c = {item: "changed"};<br />
 }

 var num = 10;<br />
 var obj1 = {item: "unchanged"};<br />
 var obj2 = {item: "unchanged"};

 console.log(obj1.item); // unchanged<br />
 console.log(obj2.item); // unchanged<br />
 changeStuff(num, obj1, obj2);<br />
 console.log(obj1.item); // changed<br />
 console.log(obj2.item); // unchanged</pre>
</div>
<p>example 2中， obj2.item并没有被函数changeStuff改变。changeStuff内部同样改变了b、c的值，为什么obj1被改变了(L15)而obj2没有被改变呢？</p>
<p>我用js的执行上下文对这种现象进行解释，如图。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/426148/201608/426148-20160813150955656-1517424002.jpg" /></p>
<p>在js运行过程中，编辑器动态生成执行上下文（execution context），example 2中，首先生成global的执行上下文和changeStuff的执行上下文。</p>
<p>执行到changeStuff(num, obj1, obj2)的时候， a, b, c指向参数num, obj1, obj2，a和num指向10， b跟obj1指向同一个值，c跟obj2指向同一个值。</p>
<p>执行step 1的时候，对a重新赋值，为a赋值前的10倍，从此a与num毫无关系。</p>
<p>执行step 2的时候，对b所指向的值的item属性进行重新赋值，这个赋值只改变了item的值， 而obj1和b仍然指向同一个值。</p>
<p>执行step 3的时候，对c重新赋值，从此c与obj2再无瓜葛，因此即使c有一个叫item的属性，与obj2的item属性有着各自的值，并没有影响obj2.item。</p>
<p>也就是说，js函数参数传递过程中，若函数内部对参数重新赋值，这个赋值过程不会影响原始变量的值。</p>
<p>这也很好地解释了基本类型的参数变量（结论1）不会受影响的现象，基本类型的参数变量每一次改变都是一次全新赋值，对原始变量不会造成影响。</p>
<h6>总结</h6>
<p>在js函数传递中，当基本类型（number, string, boolean, null, undefined, symbol）变量作为参数传递时，函数内部对参数的任何操作都不会改变变量的值。</p>
<p>当object类型变量作为参数传递时，函数内部对参数的操作会影响变量的值，<strong>除非函数内部对参数重新赋值（任何类型的值）。</strong></p>
<p><strong>Thank you!</strong></p>
<p><strong>Feel free to contact me if you have any question!</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7goe1q.html">Palindrome Pairs -- LeetCode 336</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnlyvj9.html">JVM探索之&mdash;&mdash;内存管理（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9361ww9.html">对于大量left join 的表查询，可以在关键的 连接节点字段上创建索引。</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g64nzq.html">ORA-01041&colon; 内部错误，hostdef 扩展名不存在</a>
		</li>
						<li><a href="https://www.batexi.com/a/390wpyjq.html">Defining Stored Programs</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnwdyv8.html">linux第12天   线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xy3mr9.html">JQuery操作Table元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdlmm8.html">c&plus;&plus;继承中的内存布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1dogk8.html">《OD学hadoop》第四周0716</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zpe229.html">HDU 5597 GTW likes function 打表</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mgkmkq.html">&lbrack;HDOJ1827&rsqb;Summer Holiday（强连通分量，缩点）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgl3xq.html">&lbrack;原&rsqb;使用node-mapnik和openstreetmap数据初步搭建瓦片服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdz2ok8.html">C&num; WinForm动态控件实例：口算训练</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x17m68.html">wdlinux   mysql innodb的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wod3wq.html">Biztalk2010安装及配置问题集</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkrl0v8.html">重温基础之-css盒模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7661q.html">1&period;2低级线程处理API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxddmze9.html">精读JavaScript模式&lpar;八&rpar;，JS类式继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2xjxrq.html">&num;11 Python字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e47d7x9.html">Oracle学习笔记--第2章 oracle 数据库体系结构</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j07elgq.html">senrty 配置Email</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj5xl49.html">Spring 连接数据库测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1ey2g8.html">shared pool详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z173vn9.html">java实现链表结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdevgoj9.html">visual studio 2015 企业版 序列号及官方下载地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj52gk9.html">hdu 3729 I&amp;&num;39&semi;m Telling the Truth 二分图匹配</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdy4mk8.html">Android 仿PhotoShop调色板应用&lpar;二&rpar; 透明度绘制之AlphaPatternDrawable</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okr2659.html">mysql 异常处理实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m1jpgq.html">ios-点击屏幕，隐藏键盘</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zx2r09.html">linux device driver &mdash;&mdash; 环形缓冲区的实现</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
